var axDllClass = "AutoLockActiveX.AutoLock";
var axDllCLSID = "{3414B0EA-7F2C-331A-8B05-909C1B21176A}";
var axDllAssembly = "AutoLockActiveX";
var axDllVersion = "1.0.0.0";
var axDllPublicKeyToken = "5a7651a784ba4be1";
var axDllRuntimeVer = "v2.0.50727";
var axDllFilename = "AutoLockActiveX.dll";

var regRoot, dllOK, axDll;

function RegisterActiveX() {
    if (!ActivateDll("HKCU")) {
        if (!ActivateDll("HKLM")) {
            System.Debug.outputString("Error creating ActiveX object");
        }
    }
}

function ActivateDll(root) {

    regRoot = root;

    try {
        RegisterDll();
        axDll = new ActiveXObject(axDllClass);
        dllOK = true;
    } catch (err) {
        axDll = null;
        dllOK = false;
        UnregisterDll();
    }
    return dllOK;
}

function RegisterDll() {

    try {
        var classRoot = regRoot + "\\Software\\Classes\\" + axDllClass + "\\";
        var clsidRoot = regRoot + "\\Software\\Classes\\CLSID\\" + axDllCLSID + "\\";
        var dllPath = System.Gadget.path.replace(RegExp("\\\\", "g"), "/") + "/" + axDllFilename;

        var oShell = new ActiveXObject("WScript.Shell") ;
        oShell.RegWrite(classRoot, axDllClass, "REG_SZ");
        oShell.RegWrite(classRoot + "CLSID\\", axDllCLSID, "REG_SZ");
        oShell.RegWrite(clsidRoot, axDllClass, "REG_SZ");
        oShell.RegWrite(clsidRoot + "InprocServer32\\", "mscoree.dll", "REG_SZ");
        oShell.RegWrite(clsidRoot + "InprocServer32\\ThreadingModel", "Both", "REG_SZ");
        oShell.RegWrite(clsidRoot + "InprocServer32\\Class", axDllClass, "REG_SZ");
        oShell.RegWrite(clsidRoot + "InprocServer32\\Assembly", axDllAssembly + ", Version=" + axDllVersion + ", Culture=neutral, PublicKeyToken=" + axDllPublicKeyToken, "REG_SZ");
        oShell.RegWrite(clsidRoot + "InprocServer32\\RuntimeVersion", axDllRuntimeVer, "REG_SZ");
        oShell.RegWrite(clsidRoot + "InprocServer32\\CodeBase", "file:///" + dllPath, "REG_SZ");
        oShell.RegWrite(clsidRoot + "InprocServer32\\" + axDllVersion + "\\Class", axDllClass, "REG_SZ");
        oShell.RegWrite(clsidRoot + "InprocServer32\\" + axDllVersion + "\\Assembly", axDllAssembly + ", Version=" + axDllVersion + ", Culture=neutral, PublicKeyToken=" + axDllPublicKeyToken, "REG_SZ");
        oShell.RegWrite(clsidRoot + "InprocServer32\\" + axDllVersion + "\\RuntimeVersion", axDllRuntimeVer, "REG_SZ");
        oShell.RegWrite(clsidRoot + "InprocServer32\\" + axDllVersion + "\\CodeBase", "file:///" + dllPath, "REG_SZ");
        oShell.RegWrite(clsidRoot + "ProgId\\", axDllClass, "REG_SZ");
        oShell.RegWrite(clsidRoot + "ProgId\\Implemented Categories\\{62C8FE65-4EBB-45E7-B440-6E39B2CDBF29}\\", "", "REG_SZ");
    } catch (err) {
        //System.Debug.outputString("RegisterDll: " + err.name + " - " + err.message);
    }
}

function UnregisterDll() {
    var classRoot = regRoot + "\\Software\\Classes\\" + axDllClass + "\\";
    var clsidRoot = regRoot + "\\Software\\Classes\\CLSID\\" + axDllCLSID + "\\";

    try {       
        var oShell = new ActiveXObject("WScript.Shell") ;
        oShell.RegDelete(clsidRoot + "ProgId\\Implemented Categories\\{62C8FE65-4EBB-45E7-B440-6E39B2CDBF29}\\");
        oShell.RegDelete(clsidRoot + "ProgId\\Implemented Categories\\");
        oShell.RegDelete(clsidRoot + "ProgId\\");
        oShell.RegDelete(clsidRoot + "InprocServer32\\" + axDllVersion + "\\");
        oShell.RegDelete(clsidRoot + "InprocServer32\\");
        oShell.RegDelete(clsidRoot);
        oShell.RegDelete(classRoot + "CLSID\\");
        oShell.RegDelete(classRoot);
    } catch (err) {
        //System.Debug.outputString("UnregisterDll: " + err.name + " - " + err.message);
    }
}